//+------------------------------------------------------------------+
//|                                              iObjectSwitcher.mq4 |
//|                                                        AdvisorTC |
//|                                                                  |
//|                                              http://AdvisorTC.ru |
//|                           http://www.mql4.com/ru/users/AdvisorTC |
//|                        https://login.mql5.com/ru/users/AdvisorTC |
//+------------------------------------------------------------------+
#property copyright "AdvisorTC"
#property link      "http://AdvisorTC.ru"
#property version   "3.1"
#property description "-,       "
#property description "       "
#property description " - AdvisorTC.ru.  3.1 build 5"
#property strict
#property indicator_chart_window

//     -

#include <Objecter.mqh>;
#include <Filer.mqh>;

CObjecter objecter;
CFiler filer;

extern string  _prefixName="iOS"; //   
extern bool    _isWatchStandartObj=true; //      
string _delimiter="/";
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   ReadObjectsFromFile();
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {

   return(rates_total);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                  |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,         //    
                  const long& lparam,   //    long
                  const double& dparam, //    double
                  const string& sparam  //    string
                  )
  {
//--- ,    
   if(id==CHARTEVENT_OBJECT_CREATE
      || id==CHARTEVENT_OBJECT_CHANGE
      //|| id==CHARTEVENT_OBJECT_DELETE
      || id==CHARTEVENT_OBJECT_DRAG
      //|| id==CHARTEVENT_OBJECT_ENDEDIT
      )
     {
      PlaySound("Alert");

      string comments="";
      string name,text;
      long chartID=ChartID();
      Print(ObjectsTotal());

      for(int i=0; i<ObjectsTotal(); i++)
        {
         name=ObjectName(i);
         Print(name);

         //---     
         if(//---    ?
            StringFind(name,_prefixName)>=0
            || 
            //---   ?
            (_isWatchStandartObj==true
            && 
            (StringFind(name,"Text")>=0 ||
            StringFind(name,"Label")>=0 ||
            StringFind(name,"Trendline")>=0 || 
            StringFind(name,"Arrow")>=0 || 
            StringFind(name,"Horizontal Line")>=0 || 
            StringFind(name,"Vertical Line")>=0 || 
            StringFind(name,"Channel")>=0)))
           {
            text=objecter.ObjectToString(chartID,name,_delimiter);
            if(StringLen(comments)==0) { comments=text; }
            else { comments=comments+"\n"+text; }
           } // <- if
        } // <- for

      //---   ,  
      if(StringLen(comments)>0)
        {
         filer.StringToFile(Symbol()+" "+_prefixName+".txt",comments,true);
        }
     }
   else { return; }
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
void ReadObjectsFromFile()
  {
   int handle;
   string str;
   handle=FileOpen(Symbol()+" "+_prefixName+".txt",FILE_CSV|FILE_READ);
   if(handle>0)
     {
      while(true)
        {
         str=FileReadString(handle);

         if(str=="") break;
         else { ObjectFromString(str); }
        }

      //---    
      FileClose(handle);
     }
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|  .                               |
//+------------------------------------------------------------------+
void ObjectFromString(string str)
  {

//--- String's
   string name,text,tooltip,leveltext,font,bmpfile,symbol;

   int startt=0;
   int end=StringFind(str,_delimiter,0);
   if(startt<end) { name=StringSubstr(str,startt,end); } // 

//---     
   if(ObjectFind(ChartID(),name)>=0) { return; }

   startt=end+1;
   end=StringFind(str,_delimiter,startt);
   if(startt<end) { text=StringSubstr(str,startt,end-startt); }      //  

   startt=end+1;
   end=StringFind(str,_delimiter,startt);
   if(startt<end) { tooltip=StringSubstr(str,startt,end-startt); }   // 
   startt=end+1;
   end=StringFind(str,_delimiter,startt);
   if(startt<end) { leveltext=StringSubstr(str,startt,end-startt); } //  
   startt=end+1;
   end=StringFind(str,_delimiter,startt);
   if(startt<end) { font=StringSubstr(str,startt,end-startt); }      // 
   startt=end+1;
   end=StringFind(str,_delimiter,startt);
   if(startt<end) { bmpfile=StringSubstr(str,startt,end-startt); }   //  BMP-   " "
   startt=end+1;
   end=StringFind(str,_delimiter,startt);
   if(startt<end) { symbol=StringSubstr(str,startt,end-startt); }    // 

//--- Integer's
   long col,style,width,back,zorder,fill,hidden,selected,readonly,type,time1,time2,time3,
   selectable,createtime,levels,levelcolor,levelstyle,levelwidth,align,fontsize,
   ray_right,ray,ellipse,arrowcode,timeframes,anchor,xdistance,ydistance,state,
   chart_id,xsize,ysize,xoffset,yoffset,period,date_scale,price_scale,
   chart_scale,bgcolor,corner,border_type,border_color;

   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { col=StringToInteger(StringSubstr(str,startt,end-startt)); }      // 
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { style=StringToInteger(StringSubstr(str,startt,end-startt)); }   // 
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { width=StringToInteger(StringSubstr(str,startt,end-startt)); }   // 
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { back=StringToInteger(StringSubstr(str,startt,end-startt)); }   //    
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { zorder=StringToInteger(StringSubstr(str,startt,end-startt)); }   //      
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { fill=StringToInteger(StringSubstr(str,startt,end-startt)); }   // 
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { hidden=StringToInteger(StringSubstr(str,startt,end-startt)); }   //    
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { selected=StringToInteger(StringSubstr(str,startt,end-startt)); } // 
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { readonly=StringToInteger(StringSubstr(str,startt,end-startt)); } //  
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { type=StringToInteger(StringSubstr(str,startt,end-startt)); }   // 
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { time1=StringToInteger(StringSubstr(str,startt,end-startt)); }   //  
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { time2=StringToInteger(StringSubstr(str,startt,end-startt)); }  //  
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { time3=StringToInteger(StringSubstr(str,startt,end-startt)); }   //   
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { selectable=StringToInteger(StringSubstr(str,startt,end-startt)); } //  
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { createtime=StringToInteger(StringSubstr(str,startt,end-startt)); } //  
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { levels=StringToInteger(StringSubstr(str,startt,end-startt)); }   // 
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { levelcolor=StringToInteger(StringSubstr(str,startt,end-startt)); } //  
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { levelstyle=StringToInteger(StringSubstr(str,startt,end-startt)); } //  
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { levelwidth=StringToInteger(StringSubstr(str,startt,end-startt)); } //  
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { align=StringToInteger(StringSubstr(str,startt,end-startt)); }    //  
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { fontsize=StringToInteger(StringSubstr(str,startt,end-startt)); } //  
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { ray_right=StringToInteger(StringSubstr(str,startt,end-startt)); } //   
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { ray=StringToInteger(StringSubstr(str,startt,end-startt)); } //  
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { ellipse=StringToInteger(StringSubstr(str,startt,end-startt)); } //  
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { arrowcode=StringToInteger(StringSubstr(str,startt,end-startt)); } //  
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { timeframes=StringToInteger(StringSubstr(str,startt,end-startt)); } //  
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { anchor=StringToInteger(StringSubstr(str,startt,end-startt)); } //    
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { xdistance=StringToInteger(StringSubstr(str,startt,end-startt)); } // 
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { ydistance=StringToInteger(StringSubstr(str,startt,end-startt)); }
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { state=StringToInteger(StringSubstr(str,startt,end-startt)); } //   /
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { chart_id=StringToInteger(StringSubstr(str,startt,end-startt)); } //  
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { xsize=StringToInteger(StringSubstr(str,startt,end-startt)); } //    X
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { ysize=StringToInteger(StringSubstr(str,startt,end-startt)); } //    Y
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { xoffset=StringToInteger(StringSubstr(str,startt,end-startt)); } //  
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { yoffset=StringToInteger(StringSubstr(str,startt,end-startt)); }

//---   ""
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { period=StringToInteger(StringSubstr(str,startt,end-startt)); } //  
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { date_scale=StringToInteger(StringSubstr(str,startt,end-startt)); }
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { price_scale=StringToInteger(StringSubstr(str,startt,end-startt)); }
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { chart_scale=StringToInteger(StringSubstr(str,startt,end-startt)); }
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { bgcolor=StringToInteger(StringSubstr(str,startt,end-startt)); } //  
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { corner=StringToInteger(StringSubstr(str,startt,end-startt)); } //      
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { border_type=StringToInteger(StringSubstr(str,startt,end-startt)); }
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { border_color=StringToInteger(StringSubstr(str,startt,end-startt)); }

//--- Double's
   double price1,price2,price3,levelvalue,scale,angle,deviation;

   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { price1=StringToDouble(StringSubstr(str,startt,end-startt)); } //  
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { price2=StringToDouble(StringSubstr(str,startt,end-startt)); } //  
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { price3=StringToDouble(StringSubstr(str,startt,end-startt)); } //  
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { levelvalue=StringToDouble(StringSubstr(str,startt,end-startt)); } //  
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { scale=StringToDouble(StringSubstr(str,startt,end-startt)); } // 
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { angle=StringToDouble(StringSubstr(str,startt,end-startt)); } // 
   startt=end+1; end=StringFind(str,_delimiter,startt);
   if(startt<end) { deviation=StringToDouble(StringSubstr(str,startt,end-startt)); } //   

//---  
   long chartID=ChartID();
   ObjectCreate(chartID,name,type,0,time1,price1,time2,price2,time3,price3);

//---  String's   
   ObjectSetString(chartID,name,OBJPROP_TEXT,text);
   ObjectSetString(chartID,name,OBJPROP_TOOLTIP,tooltip);
   ObjectSetString(chartID,name,OBJPROP_LEVELTEXT,leveltext);
   ObjectSetString(chartID,name,OBJPROP_FONT,font);
   ObjectSetString(chartID,name,OBJPROP_BMPFILE,bmpfile);
//ObjectSetString(chartID,name,OBJPROP_SYMBOL,symbol);

//---  Integer's
   ObjectSetInteger(chartID,name,OBJPROP_COLOR,col);
   ObjectSetInteger(chartID,name,OBJPROP_STYLE,style);
   ObjectSetInteger(chartID,name,OBJPROP_BACK,back);
   ObjectSetInteger(chartID,name,OBJPROP_ZORDER,zorder);
   ObjectSetInteger(chartID,name,OBJPROP_FILL,fill);
   ObjectSetInteger(chartID,name,OBJPROP_HIDDEN,hidden);
   ObjectSetInteger(chartID,name,OBJPROP_SELECTED,selected);
   ObjectSetInteger(chartID,name,OBJPROP_READONLY,readonly);
//ObjectSetInteger(chartID,name,OBJPROP_TYPE,type);
/*ObjectSetInteger(chartID,name,OBJPROP_TIME,0,time1);
   ObjectSetInteger(chartID,name,OBJPROP_TIME,1,time2);
   ObjectSetInteger(chartID,name,OBJPROP_TIME,2,time3);*/
   ObjectSetInteger(chartID,name,OBJPROP_SELECTABLE,selectable);
   ObjectSetInteger(chartID,name,OBJPROP_CREATETIME,createtime);
   ObjectSetInteger(chartID,name,OBJPROP_LEVELS,levels);
   ObjectSetInteger(chartID,name,OBJPROP_LEVELCOLOR,levelcolor);
   ObjectSetInteger(chartID,name,OBJPROP_LEVELSTYLE,levelstyle);
   ObjectSetInteger(chartID,name,OBJPROP_LEVELWIDTH,levelwidth);
   ObjectSetInteger(chartID,name,OBJPROP_ALIGN,align);
   ObjectSetInteger(chartID,name,OBJPROP_FONTSIZE,fontsize);
   ObjectSetInteger(chartID,name,OBJPROP_RAY_RIGHT,ray_right);
   ObjectSetInteger(chartID,name,OBJPROP_RAY,ray);
   ObjectSetInteger(chartID,name,OBJPROP_ELLIPSE,ellipse);
   ObjectSetInteger(chartID,name,OBJPROP_ARROWCODE,arrowcode);
   ObjectSetInteger(chartID,name,OBJPROP_TIMEFRAMES,timeframes);
   ObjectSetInteger(chartID,name,OBJPROP_ANCHOR,anchor);
   ObjectSetInteger(chartID,name,OBJPROP_XDISTANCE,xdistance);
   ObjectSetInteger(chartID,name,OBJPROP_YDISTANCE,ydistance);
   ObjectSetInteger(chartID,name,OBJPROP_STATE,state);
//ObjectSetInteger(chartID,name,OBJPROP_CHART_ID,chart_id);
   ObjectSetInteger(chartID,name,OBJPROP_XSIZE,xsize);
   ObjectSetInteger(chartID,name,OBJPROP_YSIZE,ysize);
   ObjectSetInteger(chartID,name,OBJPROP_XOFFSET,xoffset);
   ObjectSetInteger(chartID,name,OBJPROP_YOFFSET,yoffset);
   ObjectSetInteger(chartID,name,OBJPROP_PERIOD,period);
   ObjectSetInteger(chartID,name,OBJPROP_DATE_SCALE,date_scale);
   ObjectSetInteger(chartID,name,OBJPROP_PRICE_SCALE,price_scale);
   ObjectSetInteger(chartID,name,OBJPROP_CHART_SCALE,chart_scale);
   ObjectSetInteger(chartID,name,OBJPROP_BGCOLOR,bgcolor);
   ObjectSetInteger(chartID,name,OBJPROP_CORNER,corner);
   ObjectSetInteger(chartID,name,OBJPROP_BORDER_TYPE,border_type);
   ObjectSetInteger(chartID,name,OBJPROP_BORDER_COLOR,border_color);

//---  Double's
/*ObjectSetDouble(chartID,name,OBJPROP_PRICE,0,price1);
   ObjectSetDouble(chartID,name,OBJPROP_PRICE,1,price2);
   ObjectSetDouble(chartID,name,OBJPROP_PRICE,2,price3);*/
   ObjectSetDouble(chartID,name,OBJPROP_LEVELVALUE,levelvalue);
   ObjectSetDouble(chartID,name,OBJPROP_SCALE,scale);
   ObjectSetDouble(chartID,name,OBJPROP_ANGLE,angle);
   ObjectSetDouble(chartID,name,OBJPROP_DEVIATION,deviation);
  }
//+------------------------------------------------------------------+


/*
//+------------------------------------------------------------------+
//| Writing object parameters to file                                |
//+------------------------------------------------------------------+
bool Save(const int file_handle,
long m_chart_id,
string m_name
)
  {
   int    i,len;
   int    levels;
   string str;
   
   int m_num_points=1;
   
   
   
//--- check
   if(file_handle==INVALID_HANDLE || m_chart_id==-1)
      return(false);
//--- write startt marker - 0xFFFFFFFFFFFFFFFF
   if(FileWriteLong(file_handle,-1)!=sizeof(long))
      return(false);
//--- write object type
int type=ObjectGetInteger(m_chart_id,m_name,OBJPROP_TYPE);

   if(FileWriteInteger(file_handle,
   type,//Type(),
   INT_VALUE)!=INT_VALUE)
      return(false);
//--- write object name
   str=ObjectGetString(m_chart_id,m_name,OBJPROP_NAME);
   len=StringLen(str);
   if(FileWriteInteger(file_handle,len,INT_VALUE)!=INT_VALUE)
      return(false);
   if(len!=0) if(FileWriteString(file_handle,str,len)!=len)
      return(false);
//--- write object color
   if(FileWriteLong(file_handle,ObjectGetInteger(m_chart_id,m_name,OBJPROP_COLOR))!=sizeof(long))
      return(false);
//--- write object line style
   if(FileWriteInteger(file_handle,(int)ObjectGetInteger(m_chart_id,m_name,OBJPROP_STYLE))!=sizeof(int))
      return(false);
//--- write object line width
   if(FileWriteInteger(file_handle,(int)ObjectGetInteger(m_chart_id,m_name,OBJPROP_WIDTH))!=sizeof(int))
      return(false);
//--- write the property value "Background"
   if(FileWriteInteger(file_handle,(int)ObjectGetInteger(m_chart_id,m_name,OBJPROP_BACK),CHAR_VALUE)!=sizeof(char))
      return(false);
//--- write the property value "Selectable"
   if(FileWriteInteger(file_handle,(int)ObjectGetInteger(m_chart_id,m_name,OBJPROP_SELECTABLE),CHAR_VALUE)!=sizeof(char))
      return(false);
//--- write the property value "Timeframes"
   if(FileWriteInteger(file_handle,(int)ObjectGetInteger(m_chart_id,m_name,OBJPROP_TIMEFRAMES),INT_VALUE)!=sizeof(int))
      return(false);
//--- write comment
   str=ObjectGetString(m_chart_id,m_name,OBJPROP_TEXT);
   len=StringLen(str);
   if(FileWriteInteger(file_handle,len,INT_VALUE)!=INT_VALUE)
      return(false);
   if(len!=0) if(FileWriteString(file_handle,str,len)!=len)
      return(false);
//--- write number of points
   if(FileWriteInteger(file_handle,m_num_points,INT_VALUE)!=INT_VALUE)
      return(false);
//--- write points
   for(i=0;i<m_num_points;i++)
     {
      if(FileWriteLong(file_handle,ObjectGetInteger(m_chart_id,m_name,OBJPROP_TIME,i))!=sizeof(long))
         return(false);
      if(FileWriteDouble(file_handle,ObjectGetDouble(m_chart_id,m_name,OBJPROP_PRICE,i))!=sizeof(double))
         return(false);
     }
//--- write number of levels
   levels=(int)ObjectGetInteger(m_chart_id,m_name,OBJPROP_LEVELS);
   if(FileWriteInteger(file_handle,levels,INT_VALUE)!=INT_VALUE)
      return(false);
//--- write levels
   for(i=0;i<levels;i++)
     {
      //--- level color
      if(FileWriteLong(file_handle,ObjectGetInteger(m_chart_id,m_name,OBJPROP_LEVELCOLOR,i))!=sizeof(long))
         return(false);
      //--- level line style
      if(FileWriteInteger(file_handle,(int)ObjectGetInteger(m_chart_id,m_name,OBJPROP_LEVELSTYLE,i))!=sizeof(int))
         return(false);
      //--- level line width
      if(FileWriteInteger(file_handle,(int)ObjectGetInteger(m_chart_id,m_name,OBJPROP_LEVELWIDTH,i))!=sizeof(int))
         return(false);
      //--- level value
      if(FileWriteDouble(file_handle,ObjectGetDouble(m_chart_id,m_name,OBJPROP_LEVELVALUE,i))!=sizeof(double))
         return(false);
      //--- level name
      str=ObjectGetString(m_chart_id,m_name,OBJPROP_LEVELTEXT,i);
      len=StringLen(str);
      if(FileWriteInteger(file_handle,len,INT_VALUE)!=INT_VALUE)
         return(false);
      if(len!=0) if(FileWriteString(file_handle,str,len)!=len)
         return(false);
     }
//--- successful
   return(true);
  }
  */
/*
//+------------------------------------------------------------------+
//| Reading object parameters from file                              |
//+------------------------------------------------------------------+
bool Load(const int file_handle, 
long m_chart_id
)
  {
   int    i,len,num;
   string str;
//--- check
   if(file_handle==INVALID_HANDLE || m_chart_id==-1)
      return(false);
//--- read and check startt marker - 0xFFFFFFFFFFFFFFFF
   if(FileReadLong(file_handle)!=-1)
      return(false);
//--- read and check object type
   if(FileReadInteger(file_handle,INT_VALUE)!=Type())
      return(false);
//--- read object name
   len=FileReadInteger(file_handle,INT_VALUE);
   str=(len!=0) ? FileReadString(file_handle,len) : "";
   if(!ObjectSetString(m_chart_id,m_name,OBJPROP_NAME,str))
      return(false);
//--- read object color
   if(!ObjectSetInteger(m_chart_id,m_name,OBJPROP_COLOR,FileReadLong(file_handle)))
      return(false);
//--- read object line style
   if(!ObjectSetInteger(m_chart_id,m_name,OBJPROP_STYLE,FileReadInteger(file_handle)))
      return(false);
//--- read object line style
   if(!ObjectSetInteger(m_chart_id,m_name,OBJPROP_WIDTH,FileReadInteger(file_handle)))
      return(false);
//--- read the property value "Background"
   if(!ObjectSetInteger(m_chart_id,m_name,OBJPROP_BACK,FileReadInteger(file_handle,CHAR_VALUE)))
      return(false);
//--- read the property value "Selectable"
   if(!ObjectSetInteger(m_chart_id,m_name,OBJPROP_SELECTABLE,FileReadInteger(file_handle,CHAR_VALUE)))
      return(false);
//--- read the property value "Timeframes"
   if(!ObjectSetInteger(m_chart_id,m_name,OBJPROP_TIMEFRAMES,FileReadInteger(file_handle,INT_VALUE)))
      return(false);
//--- read comment
   len=FileReadInteger(file_handle,INT_VALUE);
   str=(len!=0) ? FileReadString(file_handle,len) : "";
   if(!ObjectSetString(m_chart_id,m_name,OBJPROP_TEXT,str))
      return(false);
//--- read number of point
   num=FileReadInteger(file_handle,INT_VALUE);
//--- read points
   if(num!=0)
     {
      for(i=0;i<num;i++)
        {
         if(!ObjectSetInteger(m_chart_id,m_name,OBJPROP_TIME,i,FileReadLong(file_handle)))
            return(false);
         if(!ObjectSetDouble(m_chart_id,m_name,OBJPROP_PRICE,i,FileReadDouble(file_handle)))
            return(false);
        }
     }
//--- read number of levels
   num=FileReadInteger(file_handle,INT_VALUE);
   if(!ObjectSetInteger(m_chart_id,m_name,OBJPROP_LEVELS,0,FileReadLong(file_handle)))
      return(false);
//--- read levels
   if(num!=0)
     {
      for(i=0;i<num;i++)
        {
         //--- level color
         if(!ObjectSetInteger(m_chart_id,m_name,OBJPROP_LEVELCOLOR,i,FileReadLong(file_handle)))
            return(false);
         //--- levelline style
         if(!ObjectSetInteger(m_chart_id,m_name,OBJPROP_LEVELSTYLE,i,FileReadInteger(file_handle)))
            return(false);
         //--- level line width
         if(!ObjectSetInteger(m_chart_id,m_name,OBJPROP_LEVELWIDTH,i,FileReadInteger(file_handle)))
            return(false);
         //--- level value
         if(!ObjectSetDouble(m_chart_id,m_name,OBJPROP_LEVELVALUE,i,FileReadDouble(file_handle)))
            return(false);
         //--- level name
         len=FileReadInteger(file_handle,INT_VALUE);
         str=(len!=0) ? FileReadString(file_handle,len) : "";
         if(!ObjectSetString(m_chart_id,m_name,OBJPROP_LEVELTEXT,i,str))
            return(false);
        }
     }
//--- successful
   return(true);
  }
//+------------------------------------------------------------------+
*/
//+------------------------------------------------------------------+
